<?php
/* Photopress uploader - original hack by shockingbird.com for b2 */

require_once( dirname(dirname(dirname(dirname( __FILE__ )))) . '/wp-config.php');

include_once('photopress-inc.php');

get_currentuserinfo();
if ($user_level == 0) //Checks to see if user has logged in
        die (__("Try logging in"));
if ($user_level < $pp_min_level) //Checks to see if user's level is high enough
        die (__("Ask the administrator to promote you."));

$allowed_types = explode(' ', trim(strtolower($pp_allowedtypes)));

// print the header
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>WordPress &rsaquo; <?php
bloginfo('name') ?> &rsaquo; <?php echo $title; ?></title>
<link rel="stylesheet" href="<?php echo $pp_siteurl; ?>/wp-admin/wp-admin.css" type="text/css" />
<link rel="shortcut icon" href="<?php echo $pp_siteurl; ?>/wp-images/wp-favicon.png" />
<meta http-equiv="Content-Type" content="text/html; charset=<?php
   echo get_settings('blog_charset'); ?>" />
<script type="text/javascript">
<!-- // idocs.com's popup tutorial rules !
function targetopener(blah, closeme, closeonly) {
        if (! (window.focus && window.opener))return true;
        window.opener.focus();
        if (! closeonly)window.opener.document.post.content.value += blah;
        if (closeme)window.close();
        return false;
}
//-->
</script>
</head>
<body>
<div class="wrap">
<?php

// resizing function: blatently stolen from the built-in 
// wordpress uploader. makes thumbs and resized images 
function pp_resize($file, $maxsize, $minsize, $prefix = '') {
    global $pp_quality;

    // 1 = GIF, 2 = JPEG, 3 = PNG

    if(file_exists($file)) {
        $type = getimagesize($file);
        
        // if the associated function doesn't exist - then it's not
        // handle. duh. i hope.
        
        if(!function_exists('imagegif') && $type[2] == 1) {
            $error = __('Filetype not supported. Image not resized.');
        }elseif(!function_exists('imagejpeg') && $type[2] == 2) {
            $error = __('Filetype not supported. Image not resized.');
        }elseif(!function_exists('imagepng') && $type[2] == 3) {
            $error = __('Filetype not supported. Image not resized.');
        } else {
        
            // create the initial copy from the original file
            if($type[2] == 1) {
                $image = imagecreatefromgif($file);
            } elseif($type[2] == 2) {
                $image = imagecreatefromjpeg($file);
            } elseif($type[2] == 3) {
                $image = imagecreatefrompng($file);
            }
            
			if (function_exists('imageantialias'))
	            imageantialias($image, TRUE);
            
            $image_attr = getimagesize($file);

            // anti-upsize fix contributed by Jono (jono@redcliffs.net)
	    // set the current image width and heights
            $image_width = $image_attr[0];
            $image_height = $image_attr[1];

            // if image is larger than defined max size
            if($image_width >= $maxsize || $image_height >= $maxsize || $image_width <= $minsize || $image_height <= $minsize) {
               // figure out the longest side            
               if($image_width > $image_height) {
                  $image_new_width = $maxsize;
                  $image_ratio = $image_width/$image_new_width;
                  $image_new_height = $image_height/$image_ratio;
                  //width is > height
               } else {
                  $image_new_height = $maxsize;
                  $image_ratio = $image_height/$image_new_height;
                  $image_new_width = $image_width/$image_ratio;
                  //height > width
               }
            
            $resized = imagecreatetruecolor($image_new_width, $image_new_height);
            @imagecopyresampled($resized, $image, 0, 0, 0, 0, $image_new_width, $image_new_height, $image_attr[0], $image_attr[1]);
            
            // move the thumbnail to it's final destination
            
            $path = explode('/', $file);
            $resizedpath = substr($file, 0, strrpos($file, '/')) . '/' . $prefix . $path[count($path)-1];
            
            if($type[2] == 1) {
                if(!imagegif($resized, $resizedpath)) {
                    $error = __("Photo path invalid");
                }
            } elseif($type[2] == 2) {
                if(!imagejpeg($resized, $resizedpath, $pp_quality)) {
                    $error = __("Photo path invalid");
                }
            } elseif($type[2] == 3) {
                if(!imagepng($resized, $resizedpath)) {
                    $error = __("Photo path invalid");
                }
            }
          } else { $error = __('Image not resized, is smaller than ' . $maxsize . 'x' . $maxsize);
	  }
        }
    }
    
    if(!empty($error))
    {
        return $error;
    }
    else
    {
        return 1;
    }
}

if ($_POST['submit']) {
        $action = 'upload';
} else {
        $action = '';
}

$pp_pathtophotos = $pp_photospath;

if (!is_writable($pp_pathtophotos))
        $action = 'not-writable';

switch ($action) {
case 'not-writable':
?>
<p><?php printf(__("It doesn't look like you can use the file upload feature at this time because the directory you have specified (<code>%s</code>) doesn't appear to be writable by WordPress. Check the permissions on the directory and for typos."), $pp_pathtophotos) ?></p>

<?php
break;
case '':
	foreach ($allowed_types as $type) {
		$type_tags[] = "<code>$type</code>";
	}
	$i = implode(', ', $type_tags);
?>
<h3>Upload an Image</h3>
<p><?php printf(__('You can upload images with the extension %1$s as long as they are no larger than %2$s <abbr title="Kilobytes">KB</abbr>. If you&#8217;re an admin you can configure these values on the Options:Photopress admin page.'), $i, $pp_maxk) ?></p>
    <form action="upload.php" method="post" enctype="multipart/form-data">
    <p>
      <label for="img1"><?php _e('File:') ?></label>
      <br />
	<input type="hidden" name="MAX_FILE_SIZE" value="<?php echo $pp_maxk * 1024 ?>" />
    <input type="file" name="img1" id="img1" size="35" class="uploadform" /></p>
    <p>
    <label for="imgdesc"><?php _e('Description:') ?></label><br />
    <input type="text" name="imgdesc" id="imgdesc" size="30" class="uploadform" />
    </p>
	
	<p><input type="submit" name="submit" value="<?php _e('Upload File') ?>" /></p>
    </form>
</div>
</body>
</html><?php 
break;
case 'upload':

	$allowedtypes = trim(strtolower($pp_allowedtypes));
	$allowedtypes = preg_replace("/ /","|",$allowedtypes);
	$pathtophotos = $pp_photospath;
	// regex for allowed filetypes, e.g. @\.(gif|png|jpg|jpeg)$@i
	$fileglob = '@\.(' . $allowedtypes . ')$@i';

	$imgalt = basename( (isset($_POST['imgalt'])) ? $_POST['imgalt'] : '' );
	$img1_name = (strlen($imgalt)) ? $imgalt : basename( $_FILES['img1']['name'] );
	$img1_name = preg_replace('/[^a-z0-9_]/i', '_', $img1_name);
	$img1_name = substr_replace($img1_name, '.', -4, 1);
	$img1_size = $_POST['img1_size'] ? intval($_POST['img1_size']) : intval($_FILES['img1']['size']);

	$img1_type = (strlen($imgalt)) ? $_POST['img1_type'] : $_FILES['img1']['type'];
	$imgdesc = htmlentities2($_POST['imgdesc']);

	$pi = pathinfo($img1_name);
	$imgtype = strtolower($pi['extension']);

	if (in_array($imgtype, $allowed_types) == false)
		die(sprintf(__('File %1$s of type %2$s is not allowed.') , $img1_name, $imgtype));

    if (strlen($imgalt)) {
        $pathtofile = $pp_pathtophotos."/".$imgalt;
        $img1 = $_POST['img1'];
    } else {
        $pathtofile = $pp_pathtophotos."/".$img1_name;
        $img1 = $_FILES['img1']['tmp_name'];
    }

    // makes sure not to upload duplicates, rename duplicates
    $i = 1;
    $pathtofile2 = $pathtofile;
    $tmppathtofile = $pathtofile2;
    $img2_name = $img1_name;

    while ( file_exists($pathtofile2) ) {
        $pos = strpos( strtolower($tmppathtofile), '.' . trim($imgtype) );
        $pathtofile_start = substr($tmppathtofile, 0, $pos);
        $pathtofile2 = $pathtofile_start.'_'.zeroise($i++, 2).'.'.trim($imgtype);
        $img2_name = explode('/', $pathtofile2);
        $img2_name = $img2_name[count($img2_name)-1];
    }

    if (file_exists($pathtofile) && !strlen($imgalt)) {
        $i = explode(' ', $pp_allowedtypes);
        $i = implode(', ',array_slice($i, 1, count($i)-2));
        $moved = move_uploaded_file($img1, $pathtofile2);
        // if move_uploaded_file() fails, try copy()
        if (!$moved) {
            $moved = copy($img1, $pathtofile2);
        }
        if (!$moved) {
            die(sprintf(__("Couldn't upload your file to %s."), $pathtofile2));
        } else {
			chmod($pathtofile2, 0666);
            @unlink($img1);
        }

	// 
    
    // duplicate-renaming function contributed by Gary Lawrence Murphy
    ?>
    <p><strong><?php __('Duplicate File?') ?></strong></p>
    <p><b><em><?php printf(__("The filename '%s' already exists!"), $img1_name); ?></em></b></p>
    <p> <?php printf(__("Filename '%1\$s' moved to '%2\$s'"), $img1, "$pathtofile2 - $img2_name") ?></p>
    <p><?php _e('Confirm or rename:') ?></p>
    <form action="upload.php" method="post" enctype="multipart/form-data">
    <input type="hidden" name="MAX_FILE_SIZE" value="<?php echo  $pp_maxk *1024 ?>" />
    <input type="hidden" name="img1_type" value="<?php echo $img1_type;?>" />
    <input type="hidden" name="img1_name" value="<?php echo $img2_name;?>" />
    <input type="hidden" name="img1_size" value="<?php echo $img1_size;?>" />
    <input type="hidden" name="img1" value="<?php echo $pathtofile2;?>" />
    <?php _e('Alternate name:') ?><br /><input type="text" name="imgalt" size="30" class="uploadform" value="<?php echo $img2_name;?>" /><br />
    <br />
    <?php _e('Description:') ?><br /><input type="text" name="imgdesc" size="30" class="uploadform" value="<?php echo $imgdesc;?>" />
    <br />
    <input type="submit" name="submit" value="<?php _e('Rename') ?>" class="search" />
    </form>
</div>
</body>
</html>
<?php 

die();

    }

    if (!strlen($imgalt)) {
        @$moved = move_uploaded_file($img1, $pathtofile); //Path to your images directory, chmod the dir to 777
        // move_uploaded_file() can fail if open_basedir in PHP.INI doesn't
        // include your tmp directory. Try copy instead?
        if(!$moved) {
            $moved = copy($img1, $pathtofile);
        }
        // Still couldn't get it. Give up.
        if (!$moved) {
            die(sprintf(__("Couldn't upload your file to %s."), $pathtofile));
        } else {
			chmod($pathtofile, 0666);
            @unlink($img1);
        }
        
    } else {
        rename($img1, $pathtofile)
        or die(sprintf(__("Couldn't upload your file to %s."), $pathtofile));
    }
    
    $resized = pp_resize($pathtofile, $pp_maxsize, 0, $pp_resizedprefix);
        if($resized != 1) {
            print $resized;
        }
    $thumb = pp_resize($pathtofile, $pp_thumbsize, $pp_thumbsize, $pp_thumbprefix);
        if($thumb != 1) {
            print $thumb;
        }
    if (empty($imgdesc)) {
        $imgdesc = strtr(substr($img1_name, 0, -4), "_", " ");
    }
    $pathtothumb = $pp_pathtophotos . '/' . $pp_thumbprefix . $img1_name;
    $thumbsize = getimagesize($pathtothumb);
    $pathtoresized = $pp_pathtophotos . '/' . $img1_name;
    $resizedsize = getimagesize($pathtoresized);
    $thumb_code = '<a href="'. $pp_imagelink . $img1_name . '" title="' . $imgdesc . '" target="' . $pp_target . '"><img src="' . $pp_photosaddress . '/' . $pp_thumbprefix . $img1_name . '" ' . $thumbsize[3] . ' alt="' . $imgdesc . '" class="' . $pp_align . '" /></a>';
    $fullsize_code = '<a href="'. $pp_imagelink . $img1_name . '" title="' . $imgdesc . '" target="' . $pp_target . '"><img src="' . $pp_photosaddress . '/' . $img1_name . '" ' . $resizedsize[3] . ' alt="' . $imgdesc . '" class="' . $pp_align . '" /></a>';

$thumb_code = htmlspecialchars( $thumb_code );
$fullsize_code = htmlspecialchars( $fullsize_code );
?>

<h3><?php _e('File uploaded!') ?></h3>
<p><?php printf(__("Your file <code>%s</code> was uploaded successfully!"), $img1_name); ?></p>

<p><img src="<?php echo $pp_photosaddress.'/'.$pp_thumbprefix.$img1_name.'" '.$thumbsize[3].' alt="'.$imgdesc; ?>" /></p>

<p><form>
<input type="button" name="close" value="Add the thumbnail to your post !" onClick="targetopener('<?php echo $thumb_code; ?>','true')" /><br />
<strong>OR</strong><br />
<input type="button" name="close" value="Add the full image to your post !" onClick="targetopener('<?php echo $fullsize_code; ?>','true')" />
</form>
</p>

<p><strong><?php _e('Image Details') ?></strong>: <br />
Name:
<?php echo $img1_name; ?>
<br />
<?php _e('Size:') ?>
<?php echo round(filesize($pathtoresized)/1024,2); ?> <?php _e('<abbr title="Kilobyte">KB</abbr>') ?><br />
<?php _e('Type:') ?>
<?php echo $img1_type; ?><br />
<?php _e('Dimensions:') ?>
<?php echo $resizedsize[0] . ' x ' . $resizedsize[1]; ?>
</p>
<p><a href="upload.php"><?php _e('Upload another') ?></a></p>
</div>
</body>
</html>
<?php
break;
}
?>
